#include <windows.h>
#include <stdio.h>
#include <thread>

#include "Core.hpp"
#include "GUI.hpp"

int     main()
{
    WindowCreate(SCREEN_WIDTH, SCREEN_HEIGHT);

    //std::thread ThreadA(GUIEntry);
    std::thread ThreadB(CoreEntry);

    int num_gpus = 0;
    cudaGetDeviceCount(&num_gpus);
    printf("Number of CUDA Cores = %d\n", num_gpus);
    for (int deviceID = 0; deviceID < num_gpus; deviceID++)
    {
        cudaDeviceProp dprop;
        cudaGetDeviceProperties(&dprop, deviceID);
        printf("   %d: %s\n", deviceID, dprop.name);
    }

    MSG  Msg;
    while (true)
    {
        PeekMessage(&Msg, NULL, NULL, NULL, PM_REMOVE);
        DispatchMessage(&Msg);
    }

    return 0;
}